#include <arpa/inet.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <stdbool.h>
#include <stdio.h>

#define BACKLOG 16

int main(void) {
	int socketfd = socket(AF_INET, SOCK_STREAM, 0);
	if(socketfd < 0) {
		perror("socket()");
		return 2;
	}

	struct sockaddr_in addr = {
		.sin_family = AF_INET,
		.sin_port = htons(15213),
		.sin_addr = {INADDR_ANY},
	};
	if(bind(socketfd, (struct sockaddr *) &addr, sizeof addr)) {
		perror("bind()");
		return 3;
	}

	if(listen(socketfd, BACKLOG)) {
		perror("listen()");
		return 4;
	}

	while(true) {
		int connfd = accept(socketfd, NULL, NULL);
		// TODO: handle error

		FILE * conn = fdopen(connfd, "r");
		// TODO: handle error

		int chr;
		while((chr = getc(conn)) != EOF)
			putchar(chr);
		putchar('\n');

		fclose(conn);
		// DONT DO THIS: close(connfd);
	}

	return 0;
}
